diff --git a/kx.c b/kx.c
index ff824785..371157b5 100644
--- a/kx.c
+++ b/kx.c
@@ -351,6 +351,7 @@ K vf_ex(V q, K g)
 
   if(!g)R 0; //??? R w converted to type7...or ?
   K z=0;
+  I f3s=0;  // Flag 3 for Subfunctions
   U(g=promote(g))
   I gn=g->n;
 
@@ -473,6 +474,14 @@ K vf_ex(V q, K g)
 
       if(!(fw=kV(f)[CACHE_WD]))
       {
+
+        if(prnt && prnt!=f && kV(prnt)[CACHE_TREE] && kV(f)[CACHE_TREE] && kK(prnt)[LOCALS]->n)
+        {
+          K j0=dot_monadic(kV(f)[CACHE_TREE]); K j1=dot_monadic(kV(prnt)[CACHE_TREE]); 
+          K j2=join(j0,j1); tree=dot_monadic(j2); ci(tree);
+          cd(j0); cd(j1); cd(j2); f3s=1;
+        }
+
         K fc = kclone(f); //clone the function to pass for _f
         cd(kV(fc)[CONJ]);kV(fc)[CONJ]=0;
         kV(fc)[DEPTH]++;
@@ -482,14 +491,16 @@ K vf_ex(V q, K g)
       }
 
       ci(fw);
-      z=ex(fw); 
-      DO(p->n,e=EVP(DI(tree,i)); cd(*e); *e=0; )
+      z=ex(fw);
+      if(f3s) cd(tree);
+      else DO(p->n,e=EVP(DI(tree,i)); cd(*e); *e=0;)
       stk--;
     )
   }
 
 cleanup:
   cd(g);
+  if(f3s) cd(tree);
   R z;
 }
 
@@ -788,7 +799,8 @@ Z K ex2(V*v, K k)  //execute words --- all returns must be Ks. v: word list, k:
         cd(kK(t3)[CACHE_TREE]); kK(t3)[CACHE_TREE]=kK(prnt)[CACHE_TREE]; ci(kK(t3)[CACHE_TREE]);
       }
     }
-    prnt=t3; 
+  if(! (prnt && kV(prnt)[PARAMS] && kK(prnt)[PARAMS]->n==2 && 
+     kV(prnt)[CACHE_WD] && kK(kK(prnt)[CACHE_WD])[LOCALS]->n==1 && kK(t3)[PARAMS]->n==1)) prnt=t3; 
   }
 
   u=*v; //Fixes a bug, see above. Not thread-safe. Adding to LOCALS probably better
diff --git a/tests.c b/tests.c
index ef09565e..e6d0d600 100644
--- a/tests.c
+++ b/tests.c
@@ -195,6 +195,7 @@ Z I tests02()
   TC_("(7 0;7 1;7 2)", "{a:5;{(7;x)}'[!3]}[]")         // More complicated variable scope
   TC(1 3, a:{x/y}; b:{a[{(x;#y)};x]}; b[(1;1 2 3)])    // Subfunctions and juxtaposition
   TC_("2 2#!4" , "a:{[f;c]f/'c}; c:2 2#!4; {d:a[{(x;y)};x];d}c") // Subfunction args & local variables
+  TC(1 2, {a:x;{[b]a,b}y}[1;2])         // Outer scope shadowed depending on argument passing syntax
 
   //Error trap: {[a;b][c;d] a+b} -> parse error ; { {[a][b] }} -> parse error
   TC(.[*; (3;4); :], (0;12) )
